Learn how to verify a user’s bank account ownership by initiating micro-deposits - small deposits that are sent to the account and must be verified by the user to confirm account ownership.
If you choose the micro-deposit method of bank verification, Dwolla will transfer two deposits of less than $0.10 to your customer’s linked bank or credit union account. After initiating micro-deposits, two random amounts will post to your customer’s bank account in 1-2 business days. Once your customer sees these deposits in their account, they need to verify the two amounts in your application. If subscribed to webhooks, your application will be notified throughout this process via micro-deposit related events.
After your customer has added a bank account you’ll want to retrieve the funding source to check if a initiate-micro-deposits link relation exists. A link to initiate-micro-deposits will return when an unverified bank funding source is eligible to receive micro-deposits.
Once you POST to the initiate-micro-deposits link, Dwolla will send two small amounts to your customer’s bank or credit union account. If the request is successful, Dwolla returns a HTTP 201 and a link to the created micro-deposits resource funding-sources/{id}/micro-deposits in the location header. The micro-deposits resource can be later used to retrieve the status of micro-deposits or verify micro-deposit amounts. If your application is subscribed to , a webhook will be sent with the microdeposits_added event, notifying your application that micro-deposits are en route to your customer’s bank account.
POST https://api-sandbox.dwolla.com/funding-sources/e52006c3-7560-4ff1-99d5-b0f3a6f4f909/micro-depositsAuthorization: Bearer 8tJjM7iTjujLthkbVPMUcHLqMNw4uv5kG712g9j1RRBHplGpwoContent-Type: application/vnd.dwolla.v1.hal+jsonAccept: application/vnd.dwolla.v1.hal+jsonCache-Control: no-cacheHTTP/1.1 201 CreatedLocation: https://api.dwolla.com/funding-sources/e52006c3-7560-4ff1-99d5-b0f3a6f4f909/micro-deposits
funding_source_url = 'https://api-sandbox.dwolla.com/funding-sources/e52006c3-7560-4ff1-99d5-b0f3a6f4f909'# Using DwollaV2 - https://github.com/Dwolla/dwolla-v2-ruby (Recommended)app_token.post '#{funding_source_url}/micro-deposits'
var fundingSourceUrl = "https://api-sandbox.dwolla.com/funding-sources/e52006c3-7560-4ff1-99d5-b0f3a6f4f909";dwolla.post(`#{fundingSourceUrl}/micro-deposits`);
funding_source_url = 'https://api-sandbox.dwolla.com/funding-sources/e52006c3-7560-4ff1-99d5-b0f3a6f4f909'# Using dwollav2 - https://github.com/Dwolla/dwolla-v2-python (Recommended)app_token.post('%s/micro-deposits' % funding_source_url)
In the Dwolla production environment, you must wait until the micro-deposits actually post to the customer’s bank account before the account can be verified, which can take 1-2 business days. A microdeposits_completed event will be triggered once micro-deposits have successfully posted to the bank. Once micro-deposits have completed, a verify-micro-deposits link relation will return on the funding source letting your application know the funding source can be verified. When the amounts are entered for verification, the order in which they are entered doesn’t matter.
In the
environment, any amount below $0.10 will allow you to verify the account
immediately.
Your customer will have only three attempts to correctly input the two posted micro-deposit amounts. If your customer reaches the max attempts allowed, a microdeposits_maxattemptsevent will be triggered and a failed-verification-micro-deposits link will be returned in the response for the funding source. As a result, they will no longer be allowed to verify the funding source using the same two posted micro-deposit amounts. In order to retry bank account verification via micro-deposits, the following steps will need to be taken by your customer and application:
Links returned on the funding source resource, e.g. failed-verification-micro-deposits, initiate-micro-deposits or verify-micro-deposits, will give your application insight into whether the funding source is eligible to receive or verify micro-deposits, or if it has already failed micro-deposit verification.